searchNodes=[{"doc":"Provides public api to Elsa. Top-level short-cuts to sub-module functions for performing basic interactions with Kafka including listing, creating, deleting, and validating topics. Also provides a function for one-off produce_sync of message(s) to a topic.","ref":"Elsa.html","title":"Elsa","type":"module"},{"doc":"See Elsa.Topic.create/3 .","ref":"Elsa.html#create_topic/3","title":"Elsa.create_topic/3","type":"function"},{"doc":"Define a default client name for establishing persistent connections to the Kafka cluster by producers and consumers. Useful for optimizing interactions by passing the identifier of a standing connection instead of instantiating a new one at each interaction, but when only a single connection is required, aleviating the need for the caller to differentiate and pass around a name.","ref":"Elsa.html#default_client/0","title":"Elsa.default_client/0","type":"function"},{"doc":"See Elsa.Topic.delete/2 .","ref":"Elsa.html#delete_topic/2","title":"Elsa.delete_topic/2","type":"function"},{"doc":"See Elsa.Fetch.fetch/3 .","ref":"Elsa.html#fetch/3","title":"Elsa.fetch/3","type":"function"},{"doc":"See Elsa.Topic.list/1 .","ref":"Elsa.html#list_topics/1","title":"Elsa.list_topics/1","type":"function"},{"doc":"See Elsa.Producer.produce/4 .","ref":"Elsa.html#produce/4","title":"Elsa.produce/4","type":"function"},{"doc":"See Elsa.Topic.exists?/2 .","ref":"Elsa.html#topic?/2","title":"Elsa.topic?/2","type":"function"},{"doc":"named connection, must be an atom","ref":"Elsa.html#t:connection/0","title":"Elsa.connection/0","type":"type"},{"doc":"endpoints to connect to kafka brokers","ref":"Elsa.html#t:endpoints/0","title":"Elsa.endpoints/0","type":"type"},{"doc":"","ref":"Elsa.html#t:hostname/0","title":"Elsa.hostname/0","type":"type"},{"doc":"","ref":"Elsa.html#t:partition/0","title":"Elsa.partition/0","type":"type"},{"doc":"","ref":"Elsa.html#t:portnum/0","title":"Elsa.portnum/0","type":"type"},{"doc":"","ref":"Elsa.html#t:topic/0","title":"Elsa.topic/0","type":"type"},{"doc":"Public api to consumer acks asynchronously for simple consumers","ref":"Elsa.Consumer.html","title":"Elsa.Consumer","type":"module"},{"doc":"Retrieves a process id of a consumer registered to the Elsa Registry and performs a consume-ack of the messages ready to be read off the topic.","ref":"Elsa.Consumer.html#ack/4","title":"Elsa.Consumer.ack/4","type":"function"},{"doc":"","ref":"Elsa.Consumer.html#t:offset/0","title":"Elsa.Consumer.offset/0","type":"type"},{"doc":"Define the behaviour and default implementations of functions for creating message handlers that will be called by Elsa worker processes.","ref":"Elsa.Consumer.MessageHandler.html","title":"Elsa.Consumer.MessageHandler","type":"behaviour"},{"doc":"Defines the macro for implementing the message handler behaviour in an application. Default implementations allow injecting of configuration into the worker process, persisting state between runs of the message handler function, or alternatively, basic processing and acknowlegement of messages.","ref":"Elsa.Consumer.MessageHandler.html#__using__/1","title":"Elsa.Consumer.MessageHandler.__using__/1","type":"macro"},{"doc":"","ref":"Elsa.Consumer.MessageHandler.html#c:handle_messages/1","title":"Elsa.Consumer.MessageHandler.handle_messages/1","type":"callback"},{"doc":"","ref":"Elsa.Consumer.MessageHandler.html#c:handle_messages/2","title":"Elsa.Consumer.MessageHandler.handle_messages/2","type":"callback"},{"doc":"","ref":"Elsa.Consumer.MessageHandler.html#c:init/1","title":"Elsa.Consumer.MessageHandler.init/1","type":"callback"},{"doc":"Defines the worker GenServer that is managed by the DynamicSupervisor. Workers are instantiated and assigned to a specific topic/partition and process messages according to the specified message handler module passed in from the manager before calling the ack function to notify the cluster the messages have been successfully processed.","ref":"Elsa.Consumer.Worker.html","title":"Elsa.Consumer.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Elsa.Consumer.Worker.html#child_spec/1","title":"Elsa.Consumer.Worker.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2 .","ref":"Elsa.Consumer.Worker.html#handle_continue/2","title":"Elsa.Consumer.Worker.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Elsa.Consumer.Worker.html#init/1","title":"Elsa.Consumer.Worker.init/1","type":"function"},{"doc":"","ref":"Elsa.Consumer.Worker.html#kafka_message_set/1","title":"Elsa.Consumer.Worker.kafka_message_set/1","type":"macro"},{"doc":"","ref":"Elsa.Consumer.Worker.html#kafka_message_set/2","title":"Elsa.Consumer.Worker.kafka_message_set/2","type":"macro"},{"doc":"Start the worker process and init the state with the given config.","ref":"Elsa.Consumer.Worker.html#start_link/1","title":"Elsa.Consumer.Worker.start_link/1","type":"function"},{"doc":"","ref":"Elsa.Consumer.Worker.html#t:init_opts/0","title":"Elsa.Consumer.Worker.init_opts/0","type":"type"},{"doc":"The running state of the worker process.","ref":"Elsa.Consumer.Worker.State.html","title":"Elsa.Consumer.Worker.State","type":"module"},{"doc":"Implements a custom version of the Registry for Elsa, allowing the registration of shared processes like brod clients as well as processes started under brod supervision. Saves the process identifier-to-name key/value pairs to ETS.","ref":"Elsa.ElsaRegistry.html","title":"Elsa.ElsaRegistry","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Elsa.ElsaRegistry.html#child_spec/1","title":"Elsa.ElsaRegistry.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Elsa.ElsaRegistry.html#init/1","title":"Elsa.ElsaRegistry.init/1","type":"function"},{"doc":"Register the pid of a process to the registry under a given name.","ref":"Elsa.ElsaRegistry.html#register_name/2","title":"Elsa.ElsaRegistry.register_name/2","type":"function"},{"doc":"Select all records within the registry and return them as a list.","ref":"Elsa.ElsaRegistry.html#select_all/1","title":"Elsa.ElsaRegistry.select_all/1","type":"function"},{"doc":"Wraps the Kernel module send/2 function with a safe call to ensure the receiving process is defined.","ref":"Elsa.ElsaRegistry.html#send/2","title":"Elsa.ElsaRegistry.send/2","type":"function"},{"doc":"Start the Elsa registery process and link it to the current process. Creates the process registry table in ETS and traps exits during the init process.","ref":"Elsa.ElsaRegistry.html#start_link/1","title":"Elsa.ElsaRegistry.start_link/1","type":"function"},{"doc":"De-register the process name from its associated pid within the registry.","ref":"Elsa.ElsaRegistry.html#unregister_name/1","title":"Elsa.ElsaRegistry.unregister_name/1","type":"function"},{"doc":"Lookup a pid from within the registry by name.","ref":"Elsa.ElsaRegistry.html#whereis_name/1","title":"Elsa.ElsaRegistry.whereis_name/1","type":"function"},{"doc":"Top-level supervisor that orchestrates all other components of the Elsa library. Allows for a single point of integration into your application supervision tree and configuration by way of a series of nested keyword lists Components not needed by a running application (if your application only consumes messages from Kafka and never producers back to it) can be safely omitted from the configuration.","ref":"Elsa.ElsaSupervisor.html","title":"Elsa.ElsaSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Elsa.ElsaSupervisor.html#child_spec/1","title":"Elsa.ElsaSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"Elsa.ElsaSupervisor.html#dynamic_supervisor/1","title":"Elsa.ElsaSupervisor.dynamic_supervisor/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1 .","ref":"Elsa.ElsaSupervisor.html#init/1","title":"Elsa.ElsaSupervisor.init/1","type":"function"},{"doc":"Defines a connection for locating the Elsa Registry process.","ref":"Elsa.ElsaSupervisor.html#registry/1","title":"Elsa.ElsaSupervisor.registry/1","type":"function"},{"doc":"Starts the top-level Elsa supervisor and links it to the current process. Starts a brod client and a custom process registry by default and then conditionally starts and takes supervision of any brod group-based consumers or producer processes defined. Options :endpoints - Required. Keyword list of kafka brokers. ex. [localhost: 9092] :connection - Required. Atom used to track kafka connection. :config - Optional. Client configuration options passed to brod. :producer - Optional. Can be a single producer configuration of multiples in a list. :group_consumer - Optional. Group consumer configuration. :consumer - Optional. Simple topic consumer configuration. Producer Config :topic - Required. Producer will be started for configured topic. :poll - Optional. If set to a number in milliseconds, will poll for new partitions and startup producers on the fly. :config - Optional. Producer configuration options passed to brod_producer . Group Consumer Config :group - Required. Name of consumer group. :topics - Required. List of topics to subscribe to. :handler - Required. Module that implements Elsa.Consumer.MessageHandler behaviour. :handler_init_args - Optional. Any args to be passed to init function in handler module. :assignment_received_handler - Optional. Arity 4 Function that will be called with any partition assignments. Return :ok to for assignment to be subscribed to. Return {:error, reason} to stop subscription. Arguments are group, topic, partition, generation_id. :assignments_revoked_handler - Optional. Zero arity function that will be called when assignments are revoked. All workers will be shutdown before callback is invoked and must return :ok . :config - Optional. Consumer configuration options passed to brod_consumer . Consumer Config :topic - Required. Topic to subscribe to. :begin_offset - Required. Where to begin consuming from. Must be either :earliest , :latest , or a valid offset integer. :handler - Required. Module that implements Elsa.Consumer.MessageHandler behaviour. :partition - Optional. Topic partition to subscribe to. If nil , will default to all partitions. :handler_init_args - Optional. Any args to be passed to init function in handler module. :poll - Optional. If set to number of milliseconds, will poll for new partitions and startup consumers on the fly. Example Elsa.ElsaSupervisor . start_link ( [ endpoints : [ localhost : 9092 ] , connection : :conn , producer : [ topic : &quot;topic1&quot; ] , consumer : [ topic : &quot;topic2&quot; , partition : 0 , begin_offset : :earliest , handler : ExampleHandler ] , group_consumer : [ group : &quot;example-group&quot; , topics : [ &quot;topic1&quot; ] , handler : ExampleHandler , config : [ begin_offset : :earliest , offset_reset_policy : :reset_to_earliest ] ] ] )","ref":"Elsa.ElsaSupervisor.html#start_link/1","title":"Elsa.ElsaSupervisor.start_link/1","type":"function"},{"doc":"Starts producer processes under Elsa's DynamicSupervisor for the specified connection. Polling cannot be configured for producers at runtime. Configuration at Elsa.ElsaSupervisor start is how polling will behave for all producers on that connection. Other than polling, producer configuration is the same as Elsa.ElsaSupervisor.start_link/1 . Producer Config :topic - Required. Producer will be started for configured topic. :config - Optional. Producer configuration options passed to brod_producer .","ref":"Elsa.ElsaSupervisor.html#start_producer/2","title":"Elsa.ElsaSupervisor.start_producer/2","type":"function"},{"doc":"","ref":"Elsa.ElsaSupervisor.html#via_name/2","title":"Elsa.ElsaSupervisor.via_name/2","type":"function"},{"doc":"Provides functions for doing one-off retrieval of messages from the Kafka cluster.","ref":"Elsa.Fetch.html","title":"Elsa.Fetch","type":"module"},{"doc":"A simple interface for quickly retrieving a message set from the cluster on the given topic. Partition and offset may be specified as keyword options, defaulting to 0 in both cases if either is not supplied by the caller.","ref":"Elsa.Fetch.html#fetch/3","title":"Elsa.Fetch.fetch/3","type":"function"},{"doc":"Retrieves all messages on a given topic across all partitions by default. Evaluates lazily, returning a Stream resource containing the messages. By default the starting offset is the earliest message offset and fetching continues until the latest offset at the time the stream is instantiated. Refine the scope of stream fetch by passing the start_offset and end_offset keyword arguments.","ref":"Elsa.Fetch.html#fetch_stream/3","title":"Elsa.Fetch.fetch_stream/3","type":"function"},{"doc":"Retrieves a stream of messages for which the supplied function evaluates to true . Search can be limited by an offset which is passed through to the underlying fetch_stream/3 call retrieving the messages to search. All options for fetch_stream/3 are respected.","ref":"Elsa.Fetch.html#search/4","title":"Elsa.Fetch.search/4","type":"function"},{"doc":"Retrieves a stream of messages where the keys contains the supplied search string. Search can be further limited by an offset which is passed through to the underlying fetch_stream/3 call retrieving the messages to search. All options for fetch_stream/3 are respected.","ref":"Elsa.Fetch.html#search_keys/4","title":"Elsa.Fetch.search_keys/4","type":"function"},{"doc":"Retrieves a stream of messages where the values contains the supplied search string. Search can be further limited by an offset which is passed through to the underlying fetch_stream/3 call retrieving the messages to search. All options for fetch_stream/3 are respected.","ref":"Elsa.Fetch.html#search_values/4","title":"Elsa.Fetch.search_values/4","type":"function"},{"doc":"Handles acknowledgement of messages to the group coordinator to prevent the group manager from queuing up messages for acknowledgement when events such as a rebalance occur.","ref":"Elsa.Group.Acknowledger.html","title":"Elsa.Group.Acknowledger","type":"module"},{"doc":"Trigger acknowledgement of processed messages back to the cluster.","ref":"Elsa.Group.Acknowledger.html#ack/2","title":"Elsa.Group.Acknowledger.ack/2","type":"function"},{"doc":"Trigger acknowledgement of processed messages back to the cluster.","ref":"Elsa.Group.Acknowledger.html#ack/5","title":"Elsa.Group.Acknowledger.ack/5","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Elsa.Group.Acknowledger.html#child_spec/1","title":"Elsa.Group.Acknowledger.child_spec/1","type":"function"},{"doc":"Retrieve the latest offset for a topic and partition. Primarily used for reinitializing consumer workers to the latest unacknowledged offset after a rebalance or other disruption.","ref":"Elsa.Group.Acknowledger.html#get_latest_offset/3","title":"Elsa.Group.Acknowledger.get_latest_offset/3","type":"function"},{"doc":"Instantiate an acknowledger process and register it to the Elsa registry.","ref":"Elsa.Group.Acknowledger.html#start_link/1","title":"Elsa.Group.Acknowledger.start_link/1","type":"function"},{"doc":"Sync the group generation ID back to the acknowledger state for validation.","ref":"Elsa.Group.Acknowledger.html#update_generation_id/2","title":"Elsa.Group.Acknowledger.update_generation_id/2","type":"function"},{"doc":"Orchestrates the creation of dynamic supervisor and worker processes for per-topic consumer groups, manager processes for coordinating topic/partition assignment, and a registry for differentiating named processes between consumer groups.","ref":"Elsa.Group.GroupSupervisor.html","title":"Elsa.Group.GroupSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Elsa.Group.GroupSupervisor.html#child_spec/1","title":"Elsa.Group.GroupSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"Elsa.Group.GroupSupervisor.html#start_link/1","title":"Elsa.Group.GroupSupervisor.start_link/1","type":"function"},{"doc":"","ref":"Elsa.Group.GroupSupervisor.html#t:init_opts/0","title":"Elsa.Group.GroupSupervisor.init_opts/0","type":"type"},{"doc":"Defines the GenServer process that coordinates assignment of workers to topics/partitions of a given consumer group. Tracks consumer group state and reinstantiates workers to the last unacknowledged message in the event of failure.","ref":"Elsa.Group.Manager.html","title":"Elsa.Group.Manager","type":"module"},{"doc":"Provides convenience for backward compatibility with previous versions of Elsa where acking for a consumer group was handled by the Elsa.Group.Manager module.","ref":"Elsa.Group.Manager.html#ack/5","title":"Elsa.Group.Manager.ack/5","type":"function"},{"doc":"Trigger the assignment of workers to a given topic and partition","ref":"Elsa.Group.Manager.html#assignments_received/4","title":"Elsa.Group.Manager.assignments_received/4","type":"function"},{"doc":"Trigger deallocation of all workers from the consumer group and stop worker processes.","ref":"Elsa.Group.Manager.html#assignments_revoked/1","title":"Elsa.Group.Manager.assignments_revoked/1","type":"function"},{"doc":"","ref":"Elsa.Group.Manager.html#brod_received_assignment/1","title":"Elsa.Group.Manager.brod_received_assignment/1","type":"macro"},{"doc":"","ref":"Elsa.Group.Manager.html#brod_received_assignment/2","title":"Elsa.Group.Manager.brod_received_assignment/2","type":"macro"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Elsa.Group.Manager.html#child_spec/1","title":"Elsa.Group.Manager.child_spec/1","type":"function"},{"doc":"Callback implementation for :brod_group_member.get_committed_offsets/2 .","ref":"Elsa.Group.Manager.html#get_committed_offsets/2","title":"Elsa.Group.Manager.get_committed_offsets/2","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2 .","ref":"Elsa.Group.Manager.html#handle_continue/2","title":"Elsa.Group.Manager.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Elsa.Group.Manager.html#init/1","title":"Elsa.Group.Manager.init/1","type":"function"},{"doc":"Start the group manager process and register a name with the process registry.","ref":"Elsa.Group.Manager.html#start_link/1","title":"Elsa.Group.Manager.start_link/1","type":"function"},{"doc":"Function called for each new assignment","ref":"Elsa.Group.Manager.html#t:assignment_received_handler/0","title":"Elsa.Group.Manager.assignment_received_handler/0","type":"type"},{"doc":"Function called for when assignments have been revoked","ref":"Elsa.Group.Manager.html#t:assignments_revoked_handler/0","title":"Elsa.Group.Manager.assignments_revoked_handler/0","type":"type"},{"doc":"The offset from wthich to begin fetch requests: default = latest","ref":"Elsa.Group.Manager.html#t:begin_offset/0","title":"Elsa.Group.Manager.begin_offset/0","type":"type"},{"doc":"Values to configure the consumer, all are optional","ref":"Elsa.Group.Manager.html#t:consumer_config/0","title":"Elsa.Group.Manager.consumer_config/0","type":"type"},{"doc":"","ref":"Elsa.Group.Manager.html#t:generation_id/0","title":"Elsa.Group.Manager.generation_id/0","type":"type"},{"doc":"","ref":"Elsa.Group.Manager.html#t:group/0","title":"Elsa.Group.Manager.group/0","type":"type"},{"doc":"Module that implements the Elsa.Consumer.MessageHandler behaviour","ref":"Elsa.Group.Manager.html#t:handler/0","title":"Elsa.Group.Manager.handler/0","type":"type"},{"doc":"keyword list of config values to start elsa consumer","ref":"Elsa.Group.Manager.html#t:init_opts/0","title":"Elsa.Group.Manager.init_opts/0","type":"type"},{"doc":"Maximum bytes to fetch in batch of messages: default = 1MB","ref":"Elsa.Group.Manager.html#t:max_bytes/0","title":"Elsa.Group.Manager.max_bytes/0","type":"type"},{"doc":"Max number of milliseconds to wait to wait for broker to collect min_bytes of messages: default = 10_000 ms","ref":"Elsa.Group.Manager.html#t:max_wait_time/0","title":"Elsa.Group.Manager.max_wait_time/0","type":"type"},{"doc":"Minimum bytes to fetch in batch of messages: default = 0","ref":"Elsa.Group.Manager.html#t:min_bytes/0","title":"Elsa.Group.Manager.min_bytes/0","type":"type"},{"doc":"How to reset begin_offset if OffsetOutOfRange exception is received","ref":"Elsa.Group.Manager.html#t:offset_reset_policy/0","title":"Elsa.Group.Manager.offset_reset_policy/0","type":"type"},{"doc":"The total number of bytes allowed to fetch-ahead: default = 100KB","ref":"Elsa.Group.Manager.html#t:prefetch_bytes/0","title":"Elsa.Group.Manager.prefetch_bytes/0","type":"type"},{"doc":"The windows size (number of messages) allowed to fetch-ahead: default = 10","ref":"Elsa.Group.Manager.html#t:prefetch_count/0","title":"Elsa.Group.Manager.prefetch_count/0","type":"type"},{"doc":"Allow consumer process to sleep this amount of ms if kafka replied with 'empty' messages: default = 1_000 ms","ref":"Elsa.Group.Manager.html#t:sleep_timeout/0","title":"Elsa.Group.Manager.sleep_timeout/0","type":"type"},{"doc":"The running state of the consumer group manager process.","ref":"Elsa.Group.Manager.State.html","title":"Elsa.Group.Manager.State","type":"module"},{"doc":"Provides functions to encapsulate the management of worker processes by the consumer group manager.","ref":"Elsa.Group.Manager.WorkerManager.html","title":"Elsa.Group.Manager.WorkerManager","type":"module"},{"doc":"","ref":"Elsa.Group.Manager.WorkerManager.html#brod_received_assignment/1","title":"Elsa.Group.Manager.WorkerManager.brod_received_assignment/1","type":"macro"},{"doc":"","ref":"Elsa.Group.Manager.WorkerManager.html#brod_received_assignment/2","title":"Elsa.Group.Manager.WorkerManager.brod_received_assignment/2","type":"macro"},{"doc":"Retrieve the generation id, used in tracking assignments of workers to topic/partition, from the worker state map.","ref":"Elsa.Group.Manager.WorkerManager.html#get_generation_id/3","title":"Elsa.Group.Manager.WorkerManager.get_generation_id/3","type":"function"},{"doc":"Restart the specified worker from the manager state. Retrieve the latest recorded offset and pass it to the new worker to pick up where the previous left off if it has been recorded.","ref":"Elsa.Group.Manager.WorkerManager.html#restart_worker/3","title":"Elsa.Group.Manager.WorkerManager.restart_worker/3","type":"function"},{"doc":"Construct an argument payload for instantiating a worker process, generate a topic/partition assignment and instantiate the worker process with both under the dynamic supervisor. Record the manager-relevant information and store in the manager state map tracking active worker processes.","ref":"Elsa.Group.Manager.WorkerManager.html#start_worker/4","title":"Elsa.Group.Manager.WorkerManager.start_worker/4","type":"function"},{"doc":"Iterate over all workers managed by the group manager and issue the unsubscribe call to disengage from the topic/partition and shut down gracefully.","ref":"Elsa.Group.Manager.WorkerManager.html#stop_all_workers/2","title":"Elsa.Group.Manager.WorkerManager.stop_all_workers/2","type":"function"},{"doc":"Tracks the running state of the worker process from the perspective of the group manager.","ref":"Elsa.Group.Manager.WorkerManager.WorkerState.html","title":"Elsa.Group.Manager.WorkerManager.WorkerState","type":"module"},{"doc":"Defines the structure of a Kafka message provided by the Elsa library and the function to construct the message struct.","ref":"Elsa.Message.html","title":"Elsa.Message","type":"module"},{"doc":"","ref":"Elsa.Message.html#kafka_message/1","title":"Elsa.Message.kafka_message/1","type":"macro"},{"doc":"","ref":"Elsa.Message.html#kafka_message/2","title":"Elsa.Message.kafka_message/2","type":"macro"},{"doc":"Constructs a message struct from the imported definition of a kafka_message as defined by the brod library with the addition of the topic and partition the message was read from as well as the optional generation id as defined by the message's relationship to a consumer group. Generation id defaults to nil in the event the message retrieved outside of the context of a consumer group.","ref":"Elsa.Message.html#new/2","title":"Elsa.Message.new/2","type":"function"},{"doc":"","ref":"Elsa.Message.html#t:elsa_message/0","title":"Elsa.Message.elsa_message/0","type":"type"},{"doc":"","ref":"Elsa.Message.html#t:kafka_message/0","title":"Elsa.Message.kafka_message/0","type":"type"},{"doc":"Behaviour for partitioning messages produced to Kafka.","ref":"Elsa.Partitioner.html","title":"Elsa.Partitioner","type":"behaviour"},{"doc":"","ref":"Elsa.Partitioner.html#c:partition/2","title":"Elsa.Partitioner.partition/2","type":"callback"},{"doc":"Partition selected by the partitioning strategy.","ref":"Elsa.Partitioner.html#t:partition/0","title":"Elsa.Partitioner.partition/0","type":"type"},{"doc":"The number of partitions for a topic.","ref":"Elsa.Partitioner.html#t:partition_count/0","title":"Elsa.Partitioner.partition_count/0","type":"type"},{"doc":"Defaults partition to 0.","ref":"Elsa.Partitioner.Default.html","title":"Elsa.Partitioner.Default","type":"module"},{"doc":"Callback implementation for Elsa.Partitioner.partition/2 .","ref":"Elsa.Partitioner.Default.html#partition/2","title":"Elsa.Partitioner.Default.partition/2","type":"function"},{"doc":"Chooses a topic partition based on an md5 hash of the supplied value, typically the message content.","ref":"Elsa.Partitioner.Md5.html","title":"Elsa.Partitioner.Md5","type":"module"},{"doc":"Callback implementation for Elsa.Partitioner.partition/2 .","ref":"Elsa.Partitioner.Md5.html#partition/2","title":"Elsa.Partitioner.Md5.partition/2","type":"function"},{"doc":"Randomly chooses a topic partition uniformly from the available number of partitions.","ref":"Elsa.Partitioner.Random.html","title":"Elsa.Partitioner.Random","type":"module"},{"doc":"Callback implementation for Elsa.Partitioner.partition/2 .","ref":"Elsa.Partitioner.Random.html#partition/2","title":"Elsa.Partitioner.Random.partition/2","type":"function"},{"doc":"Defines functions to write messages to topics based on either a list of endpoints or a named client. All produce functions support the following options: An existing named client process to handle the request can be specified by the keyword option connection: . If no partition is supplied, the first (zero) partition is chosen. Value may be a single message or a list of messages. If a list of messages is supplied as the value, the key is defaulted to an empty string binary. Partition can be specified by the keyword option partition: and an integer corresponding to a specific partition, or the keyword option partitioner: and the atoms :md5 or :random . The atoms correspond to partitioner functions that will uniformely select a random partition from the total available topic partitions or assign an integer based on an md5 hash of the messages.","ref":"Elsa.Producer.html","title":"Elsa.Producer","type":"module"},{"doc":"Write the supplied message(s) to the desired topic/partition via an endpoint list and optional named client. If no client is supplied, the default named client is chosen.","ref":"Elsa.Producer.html#produce/4","title":"Elsa.Producer.produce/4","type":"function"},{"doc":"","ref":"Elsa.Producer.html#ready?/1","title":"Elsa.Producer.ready?/1","type":"function"},{"doc":"Elsa messages can take a number of different forms, including a single binary, a key/value tuple, a map including :key and :value keys, or a list of iolists. Because Elsa supports both single messages and lists of messages and because an iolist is indistinguishable from a list of other message types from the perspective of the compiler, even single-message iolists must be wrapped in an additional list in order to be produced. Internally, all messages are converted to a map before being encoded and produced.","ref":"Elsa.Producer.html#t:message/0","title":"Elsa.Producer.message/0","type":"type"},{"doc":"Provides functions for managing and interacting with topics in the Kafka cluster.","ref":"Elsa.Topic.html","title":"Elsa.Topic","type":"module"},{"doc":"Creates the supplied topic within the cluster. Sets the number of desired partitions and replication factor for the topic based on the optional keyword list. If the optional configs are not specified by the caller, the number of partitions and replicas defaults to 1.","ref":"Elsa.Topic.html#create/3","title":"Elsa.Topic.create/3","type":"function"},{"doc":"Deletes the supplied topic from the cluster.","ref":"Elsa.Topic.html#delete/2","title":"Elsa.Topic.delete/2","type":"function"},{"doc":"Confirms or denies the existence of a topic managed by the cluster.","ref":"Elsa.Topic.html#exists?/2","title":"Elsa.Topic.exists?/2","type":"function"},{"doc":"","ref":"Elsa.Topic.html#kpro_rsp/1","title":"Elsa.Topic.kpro_rsp/1","type":"macro"},{"doc":"","ref":"Elsa.Topic.html#kpro_rsp/2","title":"Elsa.Topic.kpro_rsp/2","type":"macro"},{"doc":"Returns a list of all topics managed by the cluster as tuple of topic name and number of partitions.","ref":"Elsa.Topic.html#list/1","title":"Elsa.Topic.list/1","type":"function"},{"doc":"Provides functions for simplifying first-class interactions (consuming and producing) such as connecting to a cluster and establishing a persistent client process for interacting with a cluster.","ref":"Elsa.Util.html","title":"Elsa.Util","type":"module"},{"doc":"Process messages into chunks of size up to the size specified by the calling function in bytes, and determined by the function argument. If no chunk size is specified the default maximum size a chunk will be is approximately 1 megabyte. If no sizing function is provided to construct the appropriately sized chunks, the internal function based on Kernel.byte_size/1 is used.","ref":"Elsa.Util.html#chunk_by_byte_size/3","title":"Elsa.Util.chunk_by_byte_size/3","type":"function"},{"doc":"Determines if client pid is alive","ref":"Elsa.Util.html#client?/1","title":"Elsa.Util.client?/1","type":"function"},{"doc":"Retrieve the api version of the desired operation supported by the connected cluster.","ref":"Elsa.Util.html#get_api_version/2","title":"Elsa.Util.get_api_version/2","type":"function"},{"doc":"Return the number of partitions for a given topic. Bypasses the need for a persistent client for lighter weight interactions from one-off calls.","ref":"Elsa.Util.html#partition_count/2","title":"Elsa.Util.partition_count/2","type":"function"},{"doc":"Convert supplied cluster endpoints from common keyword list format to brod-compatible tuple.","ref":"Elsa.Util.html#reformat_endpoints/1","title":"Elsa.Util.reformat_endpoints/1","type":"function"},{"doc":"Create a named client connection process for managing interactions with the connected cluster.","ref":"Elsa.Util.html#start_client/3","title":"Elsa.Util.start_client/3","type":"function"},{"doc":"Retrieves the pid of a brod client process if it exists and executes the given function against the client.","ref":"Elsa.Util.html#with_client/2","title":"Elsa.Util.with_client/2","type":"function"},{"doc":"Wrap establishing a connection to a cluster for performing an operation.","ref":"Elsa.Util.html#with_connection/3","title":"Elsa.Util.with_connection/3","type":"function"},{"doc":"Retrieves the appropriate registry for the given value and validates it exists. Executes the function with the registry name if it successfully locates one.","ref":"Elsa.Util.html#with_registry/2","title":"Elsa.Util.with_registry/2","type":"function"},{"doc":"Provides a supervisable wrapper for the Elsa supervision tree to manage brod producers and consumers. Provides convenience functions for starting producer and consumer processes directly without the default supervisors brod interposes between them and the application. By taking over supervision of the processes directly interacting with Kafka by way of a brod client, these processes can be registered independently from the client process so in the event of the client dropping its connection, the record of what processes should be producing or consuming from what topics and partitions can be immediately reconstructed instead of being dropped.","ref":"Elsa.Wrapper.html","title":"Elsa.Wrapper","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Elsa.Wrapper.html#child_spec/1","title":"Elsa.Wrapper.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Elsa.Wrapper.html#init/1","title":"Elsa.Wrapper.init/1","type":"function"},{"doc":"","ref":"Elsa.Wrapper.html#start_link/1","title":"Elsa.Wrapper.start_link/1","type":"function"},{"doc":"","ref":"Elsa.ConnectError.html","title":"Elsa.ConnectError","type":"exception"},{"doc":"","ref":"readme.html","title":"Elsa","type":"extras"},{"doc":"Elsa is a full-featured Kafka library written in Elixir and extending the :brod library with additional support from the :kafka_protocol Erlang libraries to provide capabilities not available in :brod . Elsa has the following goals: Run entirely as a library (only start processes explicitly listed in your supervision tree) Draw none of its configuration from the calling application's app env Minimize and isolate failures in the broker/consumer interaction As Elsa draws from the Brod library (named for Kafka friend and biographer Max Brod), it is named for Elsa Taussig, Brod's wife.","ref":"readme.html#description","title":"Elsa - Description","type":"extras"},{"doc":"The package can be installed by adding elsa to your list of dependencies in mix.exs : def deps do [ { :elsa_fi , &quot;~&gt; 0.0.1&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/elsa .","ref":"readme.html#installation","title":"Elsa - Installation","type":"extras"},{"doc":"To use Elsa in your application, configure the start of the top-level supervisor to run and pass it the necessary arguments as a keyword list. Below is an example of the arguments as they might be defined in the application environment config.exs or runtime.exs files. config :my_app , :elsa_fi , endpoints : [ localhost : 9092 ] , name : :myapp_elsa , producer : [ topic : &quot;outgoing-stream&quot; ] , group_consumer : [ group : &quot;data-stream-group&quot; , topics : [ &quot;incoming-streaming&quot; ] , handler : MyApp.MessageHandler , handler_init_args : %{ } , config : [ begin_offset : :earliest ] ] , consumer : [ topic : &quot;incoming-stream&quot; , partition : 0 , begin_offset : :earliest , handler : MyApp.MessageHandler ] Note that each Elsa supervisor tree requires a single list of Kafka brokers and a single name. Beyond that, defining consumer groups or producers is optional (although defining neither will result in a relatively useless Elsa supervisor and registry). Producers may be a single producer or a list of producers, differentiated by their topic, therefore Elsa allows a one-to-many association of supervision tree to producers. Consumers and consumer groups, in contrast, have a one-to-one relationship to an Elsa supervision tree, therefore you cannot define a nested list of consumer or group_consumer keyword arguments within your Elsa configuration. Example You can find an example of configuring and using Elsa here .","ref":"readme.html#usage","title":"Elsa - Usage","type":"extras"},{"doc":"Elsa uses the standard ExUnit testing library for unit testing. For integration testing interactions with Kafka, it uses the divo library. Run tests with the command mix test.integration .","ref":"readme.html#testing","title":"Elsa - Testing","type":"extras"}]